/****************************************************************************
**
** Copyright (C) 2021 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the QtQml module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:COMM$
**
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** $QT_END_LICENSE$
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
****************************************************************************/

#ifndef QQMLPROFILEREVENTRECEIVER_P_H
#define QQMLPROFILEREVENTRECEIVER_P_H

#include "qqmlprofilerevent_p.h"
#include "qqmlprofilereventtype_p.h"

#include <QtCore/qobject.h>

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API. It exists purely as an
// implementation detail. This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

QT_BEGIN_NAMESPACE

class QQmlProfilerEventReceiver : public QObject
{
    Q_OBJECT
public:
    QQmlProfilerEventReceiver(QObject *parent = nullptr) : QObject(parent) {}

    virtual int numLoadedEventTypes() const = 0;
    virtual void addEventType(const QQmlProfilerEventType &type) = 0;
    virtual void addEvent(const QQmlProfilerEvent &event) = 0;
};

QT_END_NAMESPACE

#endif // QQMLPROFILEREVENTRECEIVER_P_H
